//Based on the cube.cpp demo by Julian Smart

/////////////////////////////////////////////////////////////////////////////
// Name:        cube.cpp
// Purpose:     wxGLCanvas demo program
// Author:      Julian Smart
// Modified by:
// Created:     04/01/98
// RCS-ID:      $Id: cube.cpp,v 1.9 2002/08/31 22:30:50 GD Exp $
// Copyright:   (c) Julian Smart
// Licence:     wxWindows licence
/////////////////////////////////////////////////////////////////////////////

#include "std_precomp.h"
#include "stam.h"

#define ID_NEW_WINDOW 10000
#define ID_DEF_ROTATE_LEFT_KEY 10001
#define ID_DEF_ROTATE_RIGHT_KEY 10002

/*----------------------------------------------------------------
  Implementation of Test-GLCanvas
-----------------------------------------------------------------*/

BEGIN_EVENT_TABLE(TestGLCanvas, wxGLCanvas)
  EVT_SIZE(TestGLCanvas::OnSize)
  EVT_PAINT(TestGLCanvas::OnPaint)
  EVT_ERASE_BACKGROUND(TestGLCanvas::OnEraseBackground)
  EVT_ENTER_WINDOW( TestGLCanvas::OnEnterWindow )
  EVT_IDLE(TestGLCanvas::OnIdle)
  EVT_MOUSE_EVENTS(TestGLCanvas::OnMouse) 
  EVT_CHAR(TestGLCanvas::OnChar) 
END_EVENT_TABLE()


TestGLCanvas::TestGLCanvas(wxWindow *parent, wxWindowID id,
    const wxPoint& pos, const wxSize& size, long style, const wxString& name, 
	int *attribList):
  wxGLCanvas(parent, (wxGLCanvas*) NULL, id, pos, size, style, name, attribList ),
  batch_printing(false), batch_print_size(0), batch_prints(0)
{
    m_init = FALSE;
    m_gllist = 0;
    m_rleft = WXK_LEFT;
    m_rright = WXK_RIGHT;

	Stam::init_data();	

}

TestGLCanvas::~TestGLCanvas()
{
	Stam::free_data();
}



void TestGLCanvas::Render()
{
    wxPaintDC dc(this);

#ifndef __WXMOTIF__
    if (!GetContext()) return;
#endif

    SetCurrent();
    // init OpenGL once, but after SetCurrent
    if (!m_init)
    {
        InitGL();
        m_init = TRUE;
    }

	gl_draw();


	SwapBuffers();
}

void TestGLCanvas::OnEnterWindow( wxMouseEvent& event )
{
    SetFocus();
}

void TestGLCanvas::OnPaint( wxPaintEvent& event )
{
    Render();
}

void TestGLCanvas::OnIdle( wxIdleEvent& event ) {

	if(!hault) {
	Stam::idle_func();
	npr::idle();
	}
	Refresh(FALSE);
}

void TestGLCanvas::OnMouse( wxMouseEvent& event ) { 
	currentUI->OnMouse(event); 
}

void TestGLCanvas::OnChar(wxKeyEvent& event) {
	currentUI->OnChar(event);
}

void TestGLCanvas::OnSize(wxSizeEvent& event)
{
    // this is also necessary to update the context on some platforms
    wxGLCanvas::OnSize(event);

    // set GL viewport (not called by wxGLCanvas::OnSize on all platforms...)
    int w, h;
    GetClientSize(&w, &h);

#ifndef __WXMOTIF__
    if (GetContext())
#endif
    {
        SetCurrent();
       /* glViewport(0, 0, (GLint) w, (GLint) h);

		glMatrixMode(GL_PROJECTION);  
		glLoadIdentity();
		gluOrtho2D(0.0, (GLdouble)w, 0.0, (GLdouble)h);
		//Gustav::winWidth = w;
		//Gustav::winHeight = h;

	

		glMatrixMode(GL_MODELVIEW);
*/
		Stam::reshape_func( w, h);


    }
}

void TestGLCanvas::OnEraseBackground(wxEraseEvent& event)
{
  // Do nothing, to avoid flashing.
}