/*
 *		This Code Was Created By Jeff Molofee 2000
 *		A HUGE Thanks To Fredric Echols For Cleaning Up
 *		And Optimizing This Code, Making It More Flexible!
 *		If You've Found This Code Useful, Please Let Me Know.
 *		Visit My Site At nehe.gamedev.net
 */

#include <nehe.h>
#include <ifl/iflFile.h>
#include <strstream>

using namespace nehe;
using namespace win_tools;

const NeheFont NeheFont::null("",0);
typedef map<NeheFont,GLuint> FontSet;
static FontSet font_set;

GLfloat nehe::PERSP_NEAR = 2.0f;
GLfloat nehe::PERSP_FAR = 100.0f;
GLfloat nehe::PERSP_ANGLE =45.0f;

namespace nehe {
	neheTexture::texture_set neheTexture::textures;
}	


/*
struct int256 { int i[256]; int256() {} };
bool operator<(const int256 &a, const int256 &b) { return a.i[0] < b.i[0]; }
typedef map<NeheFont, int256> FontWidth;
FontWidth font_width;
*/

HDC			win_tools::hDC=NULL;		// Private GDI Device Context
HGLRC		win_tools::hRC=NULL;		// Permanent Rendering Context
HWND		win_tools::hWnd=NULL;		// Holds Our Window Handle
HINSTANCE	win_tools::hInstance;		// Holds The Instance Of The Application

bool	active=TRUE;		// Window Active Flag Set To TRUE By Default
bool	fullscreen=TRUE;	// Fullscreen Flag Set To Fullscreen Mode By Default

WNDPROC WndProc = DefWindowProc;

int InitGL(GLvoid)										
{
	glClearColor(0.0f, 0.0f, 0.0f, 0.5f);

	glEnable(GL_TEXTURE_2D);											
	glEnable(GL_DEPTH_TEST);					
	glDepthFunc(GL_LEQUAL);	
	glClearDepth(1.0f);								
	
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	
	glEnable(GL_LIGHT0);
	glEnable(GL_LIGHT1);

	return TRUE;										// Initialization Went OK
}

void nehe::setWndProc(WNDPROC w) { WndProc=w; }

HCURSOR nehe::Load_arrow_ani() { return LoadCursorFromFile("arrow.ani"); } 
HCURSOR nehe::Load_IDC_ARROW() { return LoadCursor(NULL, IDC_ARROW); } 
HCURSOR nehe::Load_IDC_CROSS() { return LoadCursor(NULL, IDC_CROSS); } 

/*	This Code Creates Our OpenGL Window.  Parameters Are:					*
 *	title			- Title To Appear At The Top Of The Window				*
 *	width			- Width Of The GL Window Or Fullscreen Mode				*
 *	height			- Height Of The GL Window Or Fullscreen Mode			*
 *	bits			- Number Of Bits To Use For Color (8/16/24/32)			*
 *  cursor
 *  menu
 */

BOOL nehe::CreateGLWindow(char* title, int width, int height, int bits, HCURSOR_fun load_cursor/*, HMENU menu*/)
{
//	if(menu) fullscreen = false;

	GLuint		PixelFormat;			// Holds The Results After Searching For A Match
	WNDCLASS	wc;						// Windows Class Structure
	DWORD		dwExStyle;				// Window Extended Style
	DWORD		dwStyle;				// Window Style
	RECT		WindowRect;				// Grabs Rectangle Upper Left / Lower Right Values
	WindowRect.left=(long)0;			// Set Left Value To 0
	WindowRect.right=(long)width;		// Set Right Value To Requested Width
	WindowRect.top=(long)0;				// Set Top Value To 0
	WindowRect.bottom=(long)height;		// Set Bottom Value To Requested Height

	hInstance			= GetModuleHandle(NULL);				// Grab An Instance For Our Window
	wc.style			= CS_HREDRAW | CS_VREDRAW | CS_OWNDC;	// Redraw On Size, And Own DC For Window.
	wc.lpfnWndProc		= (WNDPROC) WndProc;					// WndProc Handles Messages
	wc.cbClsExtra		= 0;									// No Extra Window Data
	wc.cbWndExtra		= 0;									// No Extra Window Data
	wc.hInstance		= hInstance;							// Set The Instance
	wc.hIcon			= LoadIcon(NULL, IDI_WINLOGO);			// Load The Default Icon
	wc.hCursor			= load_cursor(); //LoadCursor(NULL, IDC_CROSS); //LoadCursorFromFile("arrow.ani"); // Load The Cross Pointer
	wc.hbrBackground	= NULL;									// No Background Required For GL
	wc.lpszMenuName		= NULL;									// We Don't Want A Menu
	wc.lpszClassName	= "OpenGL";								// Set The Class Name

	if (!RegisterClass(&wc))									// Attempt To Register The Window Class
	{
		MessageBox(NULL,"Failed To Register The Window Class.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Return FALSE
	}
	
	if (fullscreen)												// Attempt Fullscreen Mode?
	{
		DEVMODE dmScreenSettings;								// Device Mode
		memset(&dmScreenSettings,0,sizeof(dmScreenSettings));	// Makes Sure Memory's Cleared
		dmScreenSettings.dmSize=sizeof(dmScreenSettings);		// Size Of The Devmode Structure
		dmScreenSettings.dmPelsWidth	= width;				// Selected Screen Width
		dmScreenSettings.dmPelsHeight	= height;				// Selected Screen Height
		dmScreenSettings.dmBitsPerPel	= bits;					// Selected Bits Per Pixel
		dmScreenSettings.dmFields=DM_BITSPERPEL|DM_PELSWIDTH|DM_PELSHEIGHT;

		// Try To Set Selected Mode And Get Results.  NOTE: CDS_FULLSCREEN Gets Rid Of Start Bar.
		if (ChangeDisplaySettings(&dmScreenSettings,CDS_FULLSCREEN)!=DISP_CHANGE_SUCCESSFUL)
		{
			// If The Mode Fails, Offer Two Options.  Quit Or Use Windowed Mode.
			if (MessageBox(NULL,"The Requested Fullscreen Mode Is Not Supported By\nYour Video Card. Use Windowed Mode Instead?","NeHe GL",MB_YESNO|MB_ICONEXCLAMATION)==IDYES)
			{
				fullscreen=FALSE;		// Windowed Mode Selected.  Fullscreen = FALSE
			}
			else
			{
				// Pop Up A Message Box Letting User Know The Program Is Closing.
				MessageBox(NULL,"Program Will Now Close.","ERROR",MB_OK|MB_ICONSTOP);
				return FALSE;									// Return FALSE
			}
		}
	}

	if (fullscreen)												// Are We Still In Fullscreen Mode?
	{
		dwExStyle=WS_EX_APPWINDOW;								// Window Extended Style
		dwStyle=WS_POPUP;										// Windows Style
//		ShowCursor(FALSE);										// Hide Mouse Pointer
	}
	else
	{
		dwExStyle=WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;			// Window Extended Style
		dwStyle=WS_OVERLAPPEDWINDOW;							// Windows Style
	}

	AdjustWindowRectEx(&WindowRect, dwStyle, FALSE, dwExStyle);		// Adjust Window To True Requested Size

	// Create The Window
	if (!(hWnd=CreateWindowEx(	dwExStyle,							// Extended Style For The Window
								"OpenGL",							// Class Name
								title,								// Window Title
								dwStyle |							// Defined Window Style
								WS_CLIPSIBLINGS |					// Required Window Style
								WS_CLIPCHILDREN,					// Required Window Style
								0, 0,								// Window Position
								WindowRect.right-WindowRect.left,	// Calculate Window Width
								WindowRect.bottom-WindowRect.top,	// Calculate Window Height
								NULL,								// No Parent Window
								NULL,								// No Menu
								hInstance,							// Instance
								NULL)))								// Dont Pass Anything To WM_CREATE
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Window Creation Error.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	static	PIXELFORMATDESCRIPTOR pfd=				// pfd Tells Windows How We Want Things To Be
	{
		sizeof(PIXELFORMATDESCRIPTOR),				// Size Of This Pixel Format Descriptor
		1,											// Version Number
		PFD_DRAW_TO_WINDOW |						// Format Must Support Window
		PFD_SUPPORT_OPENGL |						// Format Must Support OpenGL
		PFD_DOUBLEBUFFER,							// Must Support Double Buffering
		PFD_TYPE_RGBA,								// Request An RGBA Format
		bits,										// Select Our Color Depth
		0, 0, 0, 0, 0, 0,							// Color Bits Ignored
		0,											// No Alpha Buffer
		0,											// Shift Bit Ignored
		0,											// No Accumulation Buffer
		0, 0, 0, 0,									// Accumulation Bits Ignored
		16,											// 16Bit Z-Buffer (Depth Buffer)  
		0,											// No Stencil Buffer
		0,											// No Auxiliary Buffer
		PFD_MAIN_PLANE,								// Main Drawing Layer
		0,											// Reserved
		0, 0, 0										// Layer Masks Ignored
	};
	
	if (!(hDC=GetDC(hWnd)))							// Did We Get A Device Context?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Create A GL Device Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if (!(PixelFormat=ChoosePixelFormat(hDC,&pfd)))	// Did Windows Find A Matching Pixel Format?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Find A Suitable PixelFormat.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if(!SetPixelFormat(hDC,PixelFormat,&pfd))		// Are We Able To Set The Pixel Format?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Set The PixelFormat.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if (!(hRC=wglCreateContext(hDC)))				// Are We Able To Get A Rendering Context?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Create A GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if(!wglMakeCurrent(hDC,hRC))					// Try To Activate The Rendering Context
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Activate The GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	ShowWindow(hWnd,SW_SHOW);						// Show The Window
	SetForegroundWindow(hWnd);						// Slightly Higher Priority
	SetFocus(hWnd);									// Sets Keyboard Focus To The Window
	ReSizeGLScene(width, height);					// Set Up Our Perspective GL Screen

	InitGL();

	return TRUE;									// Success
}

GLvoid nehe::ReSizeGLScene(GLsizei width, GLsizei height)		// Resize And Initialize The GL Window
{
	if (height==0)										// Prevent A Divide By Zero By
	{
		height=1;										// Making Height Equal One
	}

	glViewport(0,0,width,height);						// Reset The Current Viewport

	glMatrixMode(GL_PROJECTION);						// Select The Projection Matrix
	glLoadIdentity();									// Reset The Projection Matrix

	// Calculate The Aspect Ratio Of The Window
	gluPerspective(PERSP_ANGLE,(GLfloat)width/(GLfloat)height,PERSP_NEAR,PERSP_FAR);


	glMatrixMode(GL_MODELVIEW);							// Select The Modelview Matrix
	glLoadIdentity();									// Reset The Modelview Matrix
}

GLvoid nehe::KillGLWindow(GLvoid)								// Properly Kill The Window
{
	if (fullscreen)										// Are We In Fullscreen Mode?
	{
		ChangeDisplaySettings(NULL,0);					// If So Switch Back To The Desktop
		ShowCursor(TRUE);								// Show Mouse Pointer
	}

	if (hRC)											// Do We Have A Rendering Context?
	{
		if (!wglMakeCurrent(NULL,NULL))					// Are We Able To Release The DC And RC Contexts?
		{
			MessageBox(NULL,"Release Of DC And RC Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		}

		if (!wglDeleteContext(hRC))						// Are We Able To Delete The RC?
		{
			MessageBox(NULL,"Release Rendering Context Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		}
		hRC=NULL;										// Set RC To NULL
	}

	if (hDC && !ReleaseDC(hWnd,hDC))					// Are We Able To Release The DC
	{
		MessageBox(NULL,"Release Device Context Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hDC=NULL;										// Set DC To NULL
	}

	if (hWnd && !DestroyWindow(hWnd))					// Are We Able To Destroy The Window?
	{
		MessageBox(NULL,"Could Not Release hWnd.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hWnd=NULL;										// Set hWnd To NULL
	}

	if (!UnregisterClass("OpenGL",hInstance))			// Are We Able To Unregister Class
	{
		MessageBox(NULL,"Could Not Unregister Class.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hInstance=NULL;									// Set hInstance To NULL
	}
}

//I implemented this function, only to decide that I could accomplish my goals
//thing with less overhead as soon as I was done writting it.
//calculates the width of all 256 characters in a font
/*
void addFontWidth(NeheFont f_add) {
	pair<FontWidth::iterator,bool> ins=
		font_width.insert(FontWidth::value_type(f_add,int256()));	

	if(ins.second) {
		glMatrixMode(GL_PROJECTION);
		glPushMatrix();
		glLoadIdentity();
		glOrtho(0,1024,768,0,-1,10);

		glPushAttrib(GL_LIST_BIT);							// Pushes The Display List Bits
		glListBase(font_set[f_add]);								

		for(int i=0;i<256;i++) {
			glRasterPos2i(0,0);
			glCallLists(1, GL_INT , &i);	// Draws The Display List Text

			GLint rpos[4];
			glGetIntegerv(GL_CURRENT_RASTER_POSITION,rpos);

			ins.first->second.i[i]=rpos[0];
		}

		glPopAttrib();
		glPopMatrix();
		glMatrixMode(GL_MODELVIEW);
		glClear(GL_COLOR_BUFFER_BIT);
	}
}
*/

void addFont(NeheFont f_add) {
	HFONT	font;										// Windows Font ID
	font_set[f_add] = glGenLists(256);			// Storage For 256 Characters
	font = CreateFont(	f_add.height,			// Height Of Font
						0,								// Width Of Font
						0,								// Angle Of Escapement
						0,								// Orientation Angle
						FW_BOLD,						// Font Weight
						FALSE,							// Italic
						FALSE,							// Underline
						FALSE,							// Strikeout
						ANSI_CHARSET,					// Character Set Identifier
						OUT_TT_PRECIS,					// Output Precision
						CLIP_DEFAULT_PRECIS,			// Clipping Precision
						ANTIALIASED_QUALITY,			// Output Quality
						FF_DONTCARE|DEFAULT_PITCH,		// Family And Pitch
						f_add.name.c_str());					// Font Name (unknown gives a nice default)

	SelectObject(hDC, font);							// Selects The Font We Want	
	wglUseFontBitmaps(hDC, 0, 255, font_set[f_add]);				// Builds 256 Characters Starting At Character 32

	//addFontWidth(f_add);
}

GLvoid nehe::BuildFonts(const NeheFont font_list[])								// Build Our Bitmap Font
{
	int fl_size = sizeof(font_list)/sizeof(NeheFont);
	for(int i=0;i<fl_size;i++) {
		addFont(font_list[i]);	
	}
}

GLvoid nehe::KillFonts(GLvoid)									// Delete The Font
{
	for(FontSet::const_iterator i = font_set.begin(); i!=font_set.end();i++) {
		glDeleteLists(i->second,256);
	}
}
/*  Nehe's origional glPrint code
GLvoid glPrint(NeheFont font, const char *fmt, ...)					// Custom GL "Print" Routine
{
	char		text[256];								// Holds Our String
	va_list		ap;										// Pointer To List Of Arguments

	if (fmt == NULL)									// If There's No Text
		return;											// Do Nothing

	va_start(ap, fmt);									// Parses The String For Variables
	    vsprintf(text, fmt, ap);						// And Converts Symbols To Actual Numbers
	va_end(ap);											// Results Are Stored In Text

	glPushAttrib(GL_LIST_BIT);							// Pushes The Display List Bits
	glListBase(base[font]);								
	glCallLists(strlen(text), GL_UNSIGNED_BYTE, text);	// Draws The Display List Text
	glPopAttrib();										// Pops The Display List Bits
}

AUX_RGBImageRec *LoadBMP(char *Filename)			// Loads A Bitmap Image
{
	FILE *File=NULL;					// File Handle

	if (!Filename)						// Make Sure A Filename Was Given
	{
		return NULL;					// If Not Return NULL
	}

	File=fopen(Filename,"r");				// Check To See If The File Exists

	if (File)						// Does The File Exist?
	{
		fclose(File);					// Close The Handle
		return auxDIBImageLoad(Filename);		// Load The Bitmap And Return A Pointer
	}
	return NULL;						// If Load Failed Return NULL
}
*/

//i've just moved this function over from using auxDIBLoad to using
//sgi's ifl library.
//It seems to work fine, but I am made somewhat nervous by the fact that
//i am a little fuzzy on the chanel info though(dims.cm hopefully it is always 3?)
//it would be cool to see if I can find an image format that uses 4 chanells (r,g,b,w), and
//do cool alpha testing.  It would also be to get some assurance that the data that I
//get from getTile is always arranged in the most obvious fasion (rgb(w)).
void nehe::LoadGLTexture(const char * fname, GLuint tex, TextureType t) {

    iflStatus sts;
    iflFile* file = iflFile::open(fname, O_RDONLY, &sts);
    if (sts != iflOKAY) { 
		throw nehe_error::image_open_failed(fname);
	}

    // read the entire image (just the first plane in z if image has depth)
    // into a buffer of unsiged chars

    iflSize dims;
    file->getDimensions(dims);
    unsigned char* data = new unsigned char[dims.x*dims.y*dims.c];

    iflConfig cfg(iflUChar, iflInterleaved);
    sts = file->getTile(0, 0, 0, dims.x, dims.y, 1, data, &cfg);
    if (sts != iflOKAY) { /* handle error */ }
					
	// Create Linear Filtered Texture
	glBindTexture(GL_TEXTURE_2D, tex);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);



  // glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
 //  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
//   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
  // glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);


	switch(dims.c) {
	
	case 3:
	switch(t) {
	case MIP_MAPPED:
		gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB8, dims.x, dims.y, GL_RGB, GL_UNSIGNED_BYTE, data);
		break;
	case SIMPLE:
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB8, dims.x, dims.y, 0, GL_RGB, GL_UNSIGNED_BYTE, data);
		break;
	case TRANS_BLACK: 
	case MIP_TRANS_BLACK:
		{
		unsigned char * alpha=new unsigned char[4*dims.x*dims.y];		// Create Memory For RGBA8-Texture
		

		//I am just copying the Image->data into alpha,
		//while setting every 4th byte to 0 if the last color
		//was black, and 255 otherwise.
		for (int a=0; a<dims.x*dims.y; a++) {
			alpha[4*a+0]=data[3*a]; 
			alpha[4*a+1]=data[3*a+1]; 
			alpha[4*a+2]=data[3*a+2];

			// picks out a given color as transparent, like hot pink, or in this case, black			
			if(alpha[4*a+0]==0 &&
			   alpha[4*a+1]==0 &&
			   alpha[4*a+2]==0) {
				//for(int i=0;i<3;i++) alpha[4*a+i]=0;
				alpha[4*a+3]=0;
			}
			else { alpha[4*a+3]= 255; }
		}
		if(t==TRANS_BLACK) glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA8, dims.x, dims.y, 0, GL_RGBA, GL_UNSIGNED_BYTE, alpha);
		else gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGBA8, dims.x, dims.y, GL_RGBA, GL_UNSIGNED_BYTE, alpha);

		delete [] alpha;
		break;
		  }

	}
	break;

	//it has an alpha channel
	case 4:
		//glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA8, dims.x, dims.y, 0, GL_RGBA, GL_UNSIGNED_BYTE, data);
		gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGBA8, dims.x, dims.y, GL_RGBA, GL_UNSIGNED_BYTE, data);
		//fyi_msg(fname);
	break;

	case 1:
		gluBuild2DMipmaps(GL_TEXTURE_2D, 1, dims.x, dims.y, GL_LUMINANCE , GL_UNSIGNED_BYTE, data);
		break;

	case 2:
		gluBuild2DMipmaps(GL_TEXTURE_2D, 2, dims.x, dims.y, GL_LUMINANCE_ALPHA , GL_UNSIGNED_BYTE, data);
		break;
	}

	delete data;

    // close the file
    file->close();
}
/*
//load a mipmaped texture
void LoadGLTexture(const char * fname, GLuint tex) {								// Load Bitmaps And Convert To Textures
	AUX_RGBImageRec *Image=NULL;						// Create Storage Space For The Texture

	// Load The Tile-Bitmap for Base-Texture
	if (Image=auxDIBImageLoad(fname)) {
		// Create MipMapped Texture
		glBindTexture(GL_TEXTURE_2D, tex);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_NEAREST);

		gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB8, Image->sizeX, Image->sizeY, GL_RGB, GL_UNSIGNED_BYTE, Image->data);
	}

	if (Image) {								// If Texture Exists
		if (Image->data) delete Image->data;				// If Texture Image Exists
		delete Image;
		Image=NULL;
	}
}*/


#include <simple_regexp.h>

void nehe::glPrintf(TextFormat info, const char *fmt, ...)  {
	
	
	GLuint font;
	int h;
	standard_text_setup(info, font,h);
	float ySpace=info.ySpace;	
	

	char		text[256];								// Holds Our String
	va_list		ap;										// Pointer To List Of Arguments

	if (fmt == NULL)									// If There's No Text
		*text=0;											// Do Nothing

	else {
	va_start(ap, fmt);									// Parses The String For Variables
	    vsprintf(text, fmt, ap);						// And Converts Symbols To Actual Numbers
	va_end(ap);											// Results Are Stored In Text
	}

	vector<string> lines=boost_ex::split(text,'\n');

	glPushAttrib(GL_LIST_BIT | GL_CURRENT_BIT  | GL_ENABLE_BIT );	
	glDisable(GL_LIGHTING);
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_DEPTH_TEST);
	glEnable(GL_BLEND);
	glColor4ub(info.color.r,info.color.g,info.color.b,info.color.a);

	glListBase(font);

	glPushMatrix();

	for(int i=0;i<lines.size();i++) {
		glRasterPos2f(info.x,info.y);

		glCallLists(lines[i].length(), GL_UNSIGNED_BYTE, lines[i].c_str());
		glTranslatef(0,-ySpace,0);
	}
	glPopMatrix();

	glPopAttrib();								
}

void nehe::standard_text_setup(TextFormat info, GLuint &font,int&h) {
	if(info.font == NeheFont::null) {
		if(!font_set.size()) {
			addFont(NeheFont("Verdana",24));
		}
		font=font_set.begin()->second;
		h=	 font_set.begin()->first.height;
	}
	else {
		//force info.font into the font set
		FontSet::const_iterator f=font_set.find(info.font);
		if(f==font_set.end()) {
			addFont(info.font);
			f=font_set.find(info.font);
		}
		font=f->second;
		h=f->first.height;
	}
}

void nehe::glPrintf_px(TextFormat_px info, const char *fmt, ...)  {
	GLuint font;
	int h;
	if(info.font == NeheFont::null) {
		if(!font_set.size()) {
			addFont(NeheFont("Arial",24));
		}
		font=font_set.begin()->second;
		h=	 font_set.begin()->first.height;
	}
	else {
		//force info.font into the font set
		FontSet::const_iterator f=font_set.find(info.font);
		if(f==font_set.end()) {
			addFont(info.font);
			f=font_set.find(info.font);
		}
		font=f->second;
		h=f->first.height;
	}

	float yScale=info.yScale;	
	

	char		text[256];								// Holds Our String
	va_list		ap;										// Pointer To List Of Arguments

	if (fmt == NULL)									// If There's No Text
		return;											// Do Nothing

	va_start(ap, fmt);									// Parses The String For Variables
	    vsprintf(text, fmt, ap);						// And Converts Symbols To Actual Numbers
	va_end(ap);											// Results Are Stored In Text

	glPushMatrix();
	glLoadIdentity();


	glMatrixMode(GL_PROJECTION);
	glPushMatrix();

	glLoadIdentity();
	glOrtho(0,1024,768,0,-1,10);

	vector<string> lines=boost_ex::split(text,'\n');

	glPushAttrib(GL_LIST_BIT | GL_CURRENT_BIT  | GL_ENABLE_BIT );	
	glDisable(GL_LIGHTING);
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_DEPTH_TEST);
	glEnable(GL_BLEND);
	glColor4ub(info.color.r,info.color.g,info.color.b,info.color.a);

	glListBase(font);

	for(int i=0;i<lines.size();i++) {
		glRasterPos2i(info.x,info.y+i*h*info.yScale);
								
		glCallLists(lines[i].length(), GL_UNSIGNED_BYTE, lines[i].c_str());	// Draws The Display List Text
	}


	glPopAttrib();								
	glPopMatrix();

	glMatrixMode(GL_MODELVIEW);
	glPopMatrix();
}
